#!/usr/bin/perl
#
# Description: Script to retrieve data from a Motorola SB5120 Cable Modem
# Version 1.0
#
# Based on the scripts of Alives & wazoqaz
#
# SID Solutions
# http://www.sidsolutions.net
# Copyright (c) 02/06/2008
# Programmed by Sid McLaurin
#
# script name: moto_surfboard_cm.pl


use warnings;
use strict;

use LWP::Simple;

# Variables
my %data;
my %trash;
my @keys = qw(DownFreq DownSNR DownPower UpFreq UpPower);

# Get Motorola signal page
my $content = LWP::Simple::get("http://192.168.100.1/signaldata.htm") or die "Couldn't get it!";
$content =~ s/\&nbsp;|\n//g;

# regex in html source order
if ($content =~ /(<td>Frequency<\/td>)/gi) { $trash{a} =$1};
if ($content =~ /<td>(-?\d+)\sHz/gi) { $data{DownFreq} = $1; }
if ($content =~ /(<td>Signal To Noise Ratio<\/td>)/gi) { $trash{a} = $1};
if ($content =~ /<td>(-?\d+)\sdB/gi) { $data{DownSNR} = $1; }
if ($content =~ /(<td>Power Level<\/td>)/gi) { $trash{a} =$1};
if ($content =~ /<td>(-?\d+)\sdBmV/gi) { $data{DownPower} = $1; }
if ($content =~ /(<td>Frequency<\/td>)/gi) { $trash{a} =$1};
if ($content =~ /<td>(-?\d+)\sHz\s<\/td>/gi) { $data{UpFreq} = $1; }
if ($content =~ /(<td>Power Level<\/td>)/gi) { $trash{a} =$1};
if ($content =~ /<td>(-?\d+)\sdBmV/gi) { $data{UpPower} = $1; }
for (@keys) {
	print "$_:" . $data{$_} . " ";
}
print "\n";
